--[[
	BOT CONTROL SCRIPT v3 made by Bowlinghead!
	Press "F2" to gain control of a bot.
	
	Problems, bugs or suggestions? Contact me!
	Write a comment: http://www.unrealsoftware.de/files_show.php?file=16197
	Write a message: http://www.unrealsoftware.de/pm_new.php?toid=51028
	Thank you :)
	
	OLD FILE - PLEASE USE THE FINAL SCRIPT!
	
	
	Known bugs:
	- items like nightvision and flags are NOT equipable. So if the bot has a nightvision it will be lost!
	- you do not get the visual skin (you can choose your skin at choose team) of the bot. It doesn´t affect gameplay anyway.
]]--

-- Edit here if you want!
team_sens = false -- false: player also can control bots from the opposit team, true: player only can control bots of his own team


local v_value = {"maxhealth", "health", "armor", "money", "score", "deaths", "speedmod"}
local v_settings = {"setmaxhealth", "sethealth", "setarmor", "setmoney", "setscore", "setdeaths", "speedmod"} -- did you know that these commands have the same syntax? <cmd> <id> <value>
local v_botids = {} -- table of all available bot ids (gets called on botctrl_controlbot(id))
-- important: first entry = first ID; if player is no bot then it´s nil
local v_guy = {} -- syntax: { {id,bid} , {id, bid}   } || every ID,BID that is an bot
local v_alive = {} -- syntax: {true,false,true,true,...}  || always length of 32 || true: alive, false: died already (WHAT A NOOB!)

-- DELETE/MODIFY THIS ADDHOOK TO CONTROL BOT ON ANOTHER WAY!
addhook("serveraction","botctrl_serveraction")
function botctrl_serveraction(id,b)
	if (b==1) then
		if (player(id,"health")<=0) then
			if (botctrl_searchIfBot(id)==0) then
				if (botctrl_controlbot(id)==true) then -- TODO 
					msg2(id,string.char(169).."000255000You gained control of the bot!")
				else
					msg2(id,string.char(169).."255000000There is no bot available!")
				end
			else
				msg2(id,string.char(169).."255000000You already gained control of the bot this round!")
			end
		else
			msg2(id,string.char(169).."255000000You need to be dead to control a bot!")
		end
	end
end

function botctrl_startScript()
	for i=1,32 do
		v_alive[i] = false
	end
end
botctrl_startScript()

-- Function to get IDs of bots
function botctrl_getBids()
	-- delete old ids
	for i=1,#v_botids do
		table.remove(v_botids)
	end

	-- add all valid bots
	local c = 0 -- counter
	for _, id in pairs(player(0,"tableliving")) do
		if (player(id,"bot")==true) then
			if (player(id,"flag")==true) or (player(id,"process")==2) or (player(id,"reloading")==true) then -- Anti Bug - process2: bomb plant (Thx CK 4 BugReport)
				-- do nothing
			else
				c = c + 1
				v_botids[c] = id
			end
		end
	end
end

-- reset everything on spawn (= next round)
addhook("spawn","botctrl_spawn")
function botctrl_spawn(id)
	local bid = botctrl_searchIfBot(id) -- bot ID (0 if no bot)
	if (bid == nil) then bid = 0 end
	if (bid > 0) then -- if player was bot
	
		-- bot gets player stats + player gets old (=bot stats) stats
		for g=1,#v_settings do
			parse(v_settings[g].." "..bid.." "..player(id,v_value[g]))
			parse(v_settings[g].." "..id.." "..player(bid,v_value[g]))
		end
		
		-- handle v_guy array
		for i=1,#v_guy do
			if (v_guy[i][1] == id) then -- found id?
				table.remove(v_guy,i) -- delete entry
				break
			end
		end
		
		-- if player survived round then give bot the wpns
		if (v_alive[id] == true) then
			-- reset alive status
			v_alive[id] = false
			
			-- shortcuts
			local wpn_bid = playerweapons(bid)
			
			if (#wpn_bid == nil) then wpn_bid={50} end
			
			-- give bot player wpn
			for _,i in pairs(playerweapons(id)) do
				parse("equip "..bid.." "..item(i,"type")) -- equip player items
				parse("removeitem "..i)	-- remove close items (<- the items will fade out = graphical glitch)
			end
			
			-- give player bot wpn
			for _,i in pairs(wpn_bid) do
				parse("equip "..id.." "..item(i,"type"))
			end
		end
	end
end

addhook("die","botctrl_die")
function botctrl_die(vic)
	local bid = botctrl_searchIfBot(vic)
	if (bid == nil) then bid=0 end
	if (bid > 0) then -- if player was bot
		v_alive[vic] = false -- set its alive state to false
	end
end

-- searches if <id> is an bot (then return Bot ID else 0)
function botctrl_searchIfBot(id)
	local a = #v_guy -- amount of ppl that are bot
	if (a==nil) or (a==0) then return 0 end
	
	for i=1,a do
		if (v_guy[i][1] == id) then -- found ID
			return v_guy[i][2] -- bot id
		end
	end
end

-- returns true if successfully turned into a bot, else false
function botctrl_main(id,bid)
	if (bid>0) and (id>0) then
		-- shortcuts
		local b = #v_settings
		local d = #v_value
		local bx = player(bid,"tilex")
		local by = player(bid,"tiley")
		
		-- Check if teams are correct
		if (player(id,"team") ~= player(bid,"team")) then
			if (player(bid,"team")==1) then
				parse("maket "..id)
			else	
				parse("makect "..id)
			end
		end
		
		-- Spawn player on bot pos. and strip all wpns
		parse("spawnplayer "..id.." "..player(bid,"x").." "..player(bid,"y"))
		for i=1,#playerweapons(id) do
			parse("strip "..id.." "..i) -- should be a USP/Glock
		end
		
		-- save player stats temporary
		local temp = {}
		
		-- save player stats in temp + give player bot stats + give bot the temp stats (Dreieckstausch)
		for i=1,b do 
			temp[i] = player(id,v_value[i])
			parse(v_settings[i].." "..id.." "..player(bid,v_value[i]))
			parse(v_settings[i].." "..bid.." "..temp[i])
		end
		
		-- save ID,BID in v_guy
		local a = {id,bid}
		table.insert(v_guy,a)
		
		-- kill bot
		parse("killplayer "..bid)
		
		-- give player the wpns of bot
		for _,i in pairs(closeitems(id,1)) do
			parse("removeitem "..i)	-- remove close items (<- the items will fade out = graphical glitch)
			if (item(i,"type") ~= false) then 
				parse("equip "..id.." "..item(i,"type")) -- respawn items: player will pick them up + bug fix with special items (like gasmask, def. kit, etc)
			end
		end
		
		-- set player-bots alive state to 1
		v_alive[id] = true
			
		return true;
	else
		return false;
	end
end

addhook("leave","botctrl_playerAction")
addhook("join","botctrl_playerAction")
function botctrl_playerAction(id)
	-- handle v_guy array
	for i=1,#v_guy do
		if (v_guy[i][1] == id) then -- found id?
			table.remove(v_guy,i) -- delete entry
			break
		end
	end
end

-- return: analogue to _main function!!
function botctrl_controlbot(id)
	-- get bot ids
	botctrl_getBids()
	
	local c=false
	
	-- convert dead player into a living bot
	for l=1, #v_botids do
		local bid = v_botids[l] -- bot ID
		if (team_sens==true) then
			if (player(id,"team")==player(bid,"team")) then
				botctrl_bombhandle(bid)
				if (botctrl_main(id,bid)==true) then 
					c=true
					break
				end
			end
		else
			botctrl_bombhandle(bid)
			if (botctrl_main(id,bid)==true) then
				c=true
				break
			end
		end
	end
	return c;
end

function botctrl_bombhandle(bid)
	if (player(bid,"bomb")==true) then -- bot with bomb?
		local wpn = player(bid,"weapontype")
		ai_selectweapon(bid,55) -- take bomb in hand
		ai_drop(bid) -- drop bomb
		ai_selectweapon(bid,wpn) -- take old wpn 
	end
end

-- OLD FILE - PLEASE USE THE FINAL SCRIPT!