--[[
	Script for taking posession of bots when you are dead (just like in CS:GO)
	
	1. be dead
	2. spectate bots
	3. press serveraction key to take control of bot (you will respawn with bot-stats and the bot dies)
	4. all kills you get, etc. will be rewarded as if the bot did them
	
]]--


--[[
	Please edit this part
]]
bcIsTeamSens = true 	-- false: player also can control bots from the opposit team, 
						-- true : player only can control bots of his own team

bcControlButton = 1		-- Serveraction Key to control bot (1 = F2, 2 = F3,...)




--[[
	Script
]]

bcIsHoly = false	-- Do not edit! true: Next respawn/kill is holy
					-- holy action happens on:  - player respawning upon ctrling a bot
					-- 							- bots dying for players respawning
					-- 							- same vice versa on endround when wingman-player survived


function initArray()
	local array = {}
	for i = 1, 32 do
		array[i]=false
	end
	return array
end

--[[
	Both arrays will always update on death, respawn.
	Use bcBASetOne() to interact with
]]
bcBotAliveTT = initArray()
bcBotAliveCT = initArray()


-- Return: 	true = Bot is available in team
--			false = Bot is unavailable in team
function bcBotCheckAvailable(bid, team)
	local teamTable
	if (team == 1) then
		teamTable = bcBotAliveTT
	else
		teamTable = bcBotAliveCT
	end
	
	if (teamTable[bid]) then
		return true;
	end
	return false
end

-- Enable or Disable bot from public bot list
function bcBotSet(bid, value)
	if (player(bid,"bot")) then
		if (player(bid,"team")==1) then
			bcBotAliveTT[bid] = value
		else
			bcBotAliveCT[bid] = value
		end
	end
end



function bcOnSpawn(id)
	if (bcIsHoly) then -- holys (= players* respawning when controlling bot) spawn with nothing (*or bots on endround)
		bcIsHoly = false
		return "50";
	else
		-- Check if this ID is a bot and then refresh botlists
		bcBotSet(id, true)
	end
end
addhook("spawn","bcOnSpawn")

function bcOnDie(id)
	-- holys dont drop anything (=bots* when players resawpning bot) (*or players on endround)
	if (bcIsHoly) then
		bcIsHoly = false
		return 1;
	end

	-- scan for wingman-die
	local bid = 0
	for _,conn in ipairs(bcWingman) do
		if (id == conn[1]) then
			bid = conn[2]
			break
		end
	end
	
	-- WAS a wingman
	if (bid > 0) then
		-- swap stats
		local tempset = bcGetVSet(id)
		bcSetVSet(id, bcGetVSet(bid))
		bcSetVSet(bid, tempset)
		
		-- break wingman connection
		for k,v in ipairs(bcWingman) do
			if (v[1] == id and v[2] == bid) then
				table.remove(bcWingman, k)
			end
		end
		
		
	-- WASNT a wingman
	else
		-- Check if this ID is a bot and then refresh botlists
		bcBotSet(id, false)
	end
end
addhook("die","bcOnDie")


-- [pid, bid] entrys with currently alive controlling pids with the corresponding bid
bcWingman = {} --local connection = {pid, bid}

--[[
	Value/Setting System for swapping pid-stats with bid-stats.
	On SpawnKill the wingman swaps these values and will swap then back,
	once the wingman-connection dies
]]--
bcValues = {"maxhealth", "health", "armor", "money", "score", "deaths", "speedmod"}
bcSettings = {"setmaxhealth", "sethealth", "setarmor", "setmoney", "setscore", "setdeaths", "speedmod"} 

function bcParse(cmdIndex, id, value)
	parse(bcSettings[cmdIndex].." "..tostring(id).." "..tostring(value))
	--msg("Parse: "..bcSettings[cmdIndex].." "..id.." "..value)
end 

-- sets a vset of a player
function bcSetVSet(id, vset)
	for index=1, #bcValues do
		bcParse(index, id, vset[index])
	end
end

-- returns a vset of a player
function bcGetVSet(id)
	local result = {} 
	for index=1,#bcValues do
		result[index] = player(id, bcValues[index])
	end
	return result; -- <-- THIS is a pset or bset (containing all bcValues of b/p)
end

--[[
	Main bot controlling juicy part
]]--
-- Main-Action: on valid ids (check before!), then it will kill the bot and respawn the player
function bcDoControlBot(pid, bid)
	
	-- delete old bot id in the public bot-searchlist
	bcBotSet(bid, false)
	
	
	-- setup wingman connection
	local connection = {pid, bid}
	table.insert(bcWingman, connection)
	
	
	-- spawn player on position with bot stats
	bcSpawnKill(pid, bid)
end

function bcSpawnKill(pid, bid)
	
	local pset = bcGetVSet(pid)
	local bset = bcGetVSet(bid)
	local wpnlist = playerweapons(bid)
	
	-- kill bot by pset (pset.health = 0 => bot will die when setting pset onto bid)
	bcIsHoly = true
	bcSetVSet(bid, pset)
	
	
	-- spawn the player holy
	bcIsHoly = true
	parse("spawnplayer "..pid.." "..player(bid,"x").." "..player(bid,"y")) -- OnSpawn will set IsHoly on false!
	
	
	-- override pstats
	bcSetVSet(pid, bset)
	
	
	-- swap wpns
	for _,wpnid in ipairs(wpnlist) do
		parse("equip "..pid.." "..wpnid)
	end
	
	-- swap specialls like NVs, Bomb,...
	--> bot dies first and hopefully drops the bomb, NVs
	
	
end

--[[
	START/ ENDROUND
]]
-- InitBotAlives, typical on startround
function bcInitBotTables()
	for k,v in ipairs(player(0,"tableliving")) do
		if (player(v,"bot")) then
			if (player(v,"team") == 1) then
				bcBotAliveTT[v] = true
			else
				bcBotAliveCT[v] = true
			end
		end
	end
end
addhook("startround","bcInitBotTables")
addhook("endround","bcEndround")
function bcEndround()
	-- wingman-swap when wingman-player survived
	for k,v in ipairs(bcWingman) do
		table.remove(bcWingman, k)
		bcSpawnKill(v[2], v[1])
	end
end

addhook("leave","bcLeave")
function bcLeave(id)
	for k,v in ipairs(bcWingman) do
		if (v[1] == id) then -- if player is wingman currently
			table.remove(bcWingman, k)
			bcSpawnKill(v[2], id)
			return; -- no need to search further
		end
	end
end

--[[
	Serveraction/Input
]]
addhook("serveraction","bcServeraction")
function bcServeraction(id, b)
	-- wrong button
	if (b ~= bcControlButton) then return; end

	-- not dead yet
	if (player(id,"health") > 0) then 
		msg2(id,"You can only control a bot once you are dead")
		return; 
	end

	-- check team
	local isCorrectTeam = false
	local specId = player(id,"spectating")
	local playerTeam = player(id,"team")
	
	if (bcIsTeamSens) then
		if (playerTeam == player(specId,"team")) then
			if (specId > 0) then
				isCorrectTeam = bcBotCheckAvailable(specId, playerTeam)
			end
		end
	else
		if (specId > 0) then
			if (bcBotCheckAvailable(specId, 1) or bcBotCheckAvailable(specId, 2)) then
				isCorrectTeam = true
			end
		end
	end
	
	if (isCorrectTeam) then
		msg2(id,"Bot is controllable!")
		bcDoControlBot(id, specId)
	else
		msg2(id,"The player you are spectating is not controllable.")
	end
end









